离散化学习笔记&例题题解
离散化
1、本质
离散化的本质,是映射,将间隔很大的点,映射到相邻的数组元素中,且不改变原数组元素的大小。减少了对空间的需求,也减少计算量。
例如数组a[]={1,1000000000,200000},对应的离散后的数组就是b[]={1,3,2},将实际大小,转化为在新数组的下标相对大小。
2、方法
总得来说离散化分为三步:
1.排序
2.去重
3.离散
第一步不用多说,一个sort即可。
第二步在c++中可以利用自带的unique函数,可以将所有重复元素放入数组末尾,返回去重后的尾地址。
第三步有两个方法:第一个用二分查找原数组中元素在新数组的对应下标,时间复杂度O(logn),还有一种就是STL大法了,利用map的映射,可以将时间复杂度降为O(1)。
例题:洛谷P1955
https://www.luogu.com.cn/problem/P1955
思路:
首先这题可以考虑到使用并查集,我们先处理e为1的情况,也就是先把所有相等的元素放入一个同一个集合中,接着将e==0看作查询,也就是判断需查询的两个元素是否相等(也就是是否位于同一个集合中),若相等,就矛盾了,输出"NO",反之,则满足题意。
以下是ac代码(附带详细注释)
#include<bits/stdc++.h>
#include<unordered_map>
using namespace std;
#define rep(i,a,b) for(int i=(a);i<=(b);i++)
#define lop(i,a,b) for(int i=(a);i<(b);i++)
#define dwn(i,a,b) for(int i=(a);i>=(b);i--)
#define el '\n'
#define int long long//这题肯定是要开LL的,当时偷懒了写了这句,读者需注意
using LL = long long;
typedef pair<LL,LL> PII;
const int N=2e6+10;//每次插入都是2个下标,所以要开2*n
int n;
int f[N];//并查集
int find(int x)//并查集找祖先板子
{
return x==f[x]?x:f[x]=find(f[x]);
}
void solve()
{
vector<PII>add,query;//前者是e==1,也就是插入,第二个是e==0,也就是查询
vector<int>all;//所有出现过的下标都存进去
cin>>n;
rep(i,1,n)
{
int x,y,e;
cin>>x>>y>>e;
if(e==1)add.push_back({x,y});
else query.push_back({x,y});
all.push_back(x);
all.push_back(y);
}
//离散化
sort(all.begin(),all.end());//第一步,排序
all.erase(unique(all.begin(),all.end()),all.end());//第二步去重
unordered_map<int,int>get;//映射,由于我们只需要映射关系,不需要排序,所以用unordered_map,比map快
rep(i,1,all.size())
get[all[i-1]]=i;//这就是离散的过程了,把原大小,转化为从1开始的下标
//并查集
rep(i,1,N)f[i]=i;//并查集的初始化
for(auto i:add)
{
int idx1=get[i.first],idx2=get[i.second];
f[find(idx1)]=find(idx2);//并查集的并集操作
}
int flag=1;
for(auto i:query)
{
if(find(get[i.first])==find(get[i.second]))//如思路所说
{
flag=0;
break;
}
}
//依题意输出
if(flag)cout<<"YES"<<el;
else cout<<"NO"<<el;
}
signed main()
{
ios::sync_with_stdio(0),cin.tie(0),cout.tie(0);
int t = 1;
cin>>t;
while(t--)
solve();
return 0;
}
相关推荐
离散化详解+例题+程序
NOIP离散化是考试内容,很多同学对离散化并不理解,本文通过非常多的例题由浅入深的讲解,看完必会。
连续数值的离散化方法
详细描述了连续数据离散化的方法,阐述的比较详细
离散化(C++).pptx
离散化(C++) 对于“什么是离散化”,搜索帖子你会发现有各种说法,比如“排序后处理”、“对坐标的近似处理”等等。哪个是对的呢?哪个都对。关键在于,这需要一些例子和不少的讲解才能完全解释清楚离散化是程序设计中一个非常常用的技巧,它可以有效的降低时间复杂度。其基本思想就是在众多可能的情况中“只考虑我需要用的值”。下面我将用三个例子说明,如何运用离散化改进一个低效的,甚至根本不可能实现的算法《算法艺术与信息学竞赛》中的计算几何部分,黄亮举了一个经典的例子,我认为很适合用来介绍离散化思想。这个问题是UVA10173,题目意思很简单,给定平面上n个点的坐标,求能够覆盖所有这些点的最小矩形面积。这个问题难就难在,这个矩形可以倾斜放置(边不必平行于坐标轴)。 1559716576301723650.jpg 这里的倾斜放置很不好处理,因为我们不知道这个矩形最终会倾斜多少度。假设我们知道这个矩形的倾角是α,那么答案就很简单了:矩形面积最小时四条边一定都挨着某个点。也就是说,四条边的斜率已经都知道了的话,只需要让这些边从外面不断逼近这个点集直到碰到了某个点。你不必知道这个具体应该怎么实现,只需要理
学习笔记-双指针算法-位运算-离散化-区间合并
学习笔记-双指针算法-位运算-离散化-区间合并
高逸涵《与圆有关的离散化方法》高逸涵《与圆有关的离散化方法》高逸涵《与圆有关的离散化方法》高逸涵《与圆有关的离散化方法》
在计算几何问题中,离散化方法是一种较为通用的算法,在解决一些与矩形等直线型有关的题目时,能大大降低算法的时空复杂度。但当问题与圆相关时,直接离散化法有较大困难。本文讨论了离散化法在这类问题中的方法,然后通过几道例题说明如何利用离散化法解决与圆有关的计算几何问题。在计算几何问题中,离散化方法是一种较为通用的算法,在解决一些与矩形等直线型有关的题目时,能大大降低算法的时空复杂度。但当问题与圆相关时,直接离散化法有较大困难。本文讨论了离散化法在这类问题中的方法,然后通过几道例题说明如何利用离散化法解决与圆有关的计算几何问题。在计算几何问题中,离散化方法是一种较为通用的算法,在解决一些与矩形等直线型有关的题目时,能大大降低算法的时空复杂度。但当问题与圆相关时,直接离散化法有较大困难。本文讨论了离散化法在这类问题中的方法,然后通过几道例题说明如何利用离散化法解决与圆有关的计算几何问题。


